Emacs SMTP Library
******************

Copyright © 2003–2019 Free Software Foundation, Inc.

     Permission is granted to copy, distribute and/or modify this
     document under the terms of the GNU Free Documentation License,
     Version 1.3 or any later version published by the Free Software
     Foundation; with no Invariant Sections, with the Front-Cover Texts
     being “A GNU Manual”, and with the Back-Cover Texts as in (a)
     below.  A copy of the license is included in the section entitled
     “GNU Free Documentation License”.

     (a) The FSF’s Back-Cover Text is: “You have the freedom to copy and
     modify this GNU manual.”

Indices

1 How Mail Works
****************

On the internet, mail is sent from mail host to mail host using the
simple mail transfer protocol (SMTP). To send and receive mail, you must
get it from and send it to a mail host.  Every mail host runs a mail
transfer agent (MTA) such as Exim that accepts mails and passes them on.
The communication between a mail host and other clients does not
necessarily involve SMTP, however.  Here is short overview of what is
involved.

   The mail program—also called a mail user agent (MUA)—usually sends
outgoing mail to a mail host.  When your computer is permanently
connected to the internet, it might even be a mail host itself.  In this
case, the MUA will pipe mail to the ‘/usr/lib/sendmail’ application.  It
will take care of your mail and pass it on to the next mail host.

   When you are only connected to the internet from time to time, your
internet service provider (ISP) has probably told you which mail host to
use.  You must configure your MUA to use that mail host.  Since you are
reading this manual, you probably want to configure Emacs to use SMTP to
send mail to that mail host.  More on that in the next section.

   Things are different when reading mail.  The mail host responsible
for your mail keeps it in a file somewhere.  The messages get into the
file by way of a mail delivery agent (MDA) such as procmail.  These
delivery agents often allow you to filter and munge your mails before
you get to see it.  When your computer is that mail host, this file is
called a spool, and sometimes located in the directory
‘/var/spool/mail/’.  All your MUA has to do is read mail from the spool,
then.

   When your computer is not always connected to the internet, you must
get the mail from the remote mail host using a protocol such as POP3 or
IMAP.  POP3 essentially downloads all your mail from the mail host to
your computer.  The mail is stored in some file on your computer, and
again, all your MUA has to do is read mail from the spool.

   When you read mail from various machines, downloading mail from the
mail host to your current machine is not convenient.  In that case, you
will probably want to use the IMAP protocol.  Your mail is kept on the
mail host, and you can read it while you are connected via IMAP to the
mail host.

   So how does reading mail via the web work, you ask.  In that case,
the web interface just allows you to remote-control a MUA on the web
host.  Whether the web host is also a mail host, and how all the pieces
interact is completely irrelevant.  You usually cannot use Emacs to read
mail via the web, unless you use software that parses the ever-changing
HTML of the web interface.

2 Emacs Speaks SMTP
*******************

Emacs includes a package for sending your mail to a SMTP server and have
it take care of delivering it to the final destination, rather than
letting the MTA on your local system take care of it.  This can be
useful if you don’t have a MTA set up on your host, or if your machine
is often disconnected from the internet.

   Sending mail via SMTP requires configuring your mail user agent
(see Mail Methods (emacs)) to use the SMTP library.  If you have not
configured anything, then in Emacs 24.1 and later the first time you try
to send a mail Emacs will ask how you want to send mail.  To use this
library, answer ‘smtp’ when prompted.  Emacs then asks for the name of
the SMTP server.

   If you prefer, or if you are using a non-standard mail user agent,
you can configure this yourself.  The normal way to do this is to set
the variable ‘send-mail-function’ (see Mail Sending (emacs)) to the
value you want to use.  To use this library:

     (setq send-mail-function 'smtpmail-send-it)

The default value for this variable is ‘sendmail-query-once’, which
interactively asks how you want to send mail.

   Your mail user agent might use a different variable for this purpose.
It should inherit from ‘send-mail-function’, but if it does not, or if
you prefer, you can set that variable directly.  Consult your mail user
agent’s documentation for more details.  For example, (see
Mail Variables (message)).

   Before using SMTP you must find out the hostname of the SMTP server
to use.  Your system administrator or mail service provider should
supply this information.  Often it is some variant of the server you
receive mail from.  If your email address is ‘yourname@example.com’,
then the name of the SMTP server is may be something like
‘smtp.example.com’.

‘smtpmail-smtp-server’
     The variable ‘smtpmail-smtp-server’ controls the hostname of the
     server to use.  It is a string with an IP address or hostname.  It
     defaults to the contents of the ‘SMTPSERVER’ environment variable,
     or, if empty, the contents of ‘smtpmail-default-smtp-server’.

‘smtpmail-default-smtp-server’
     The variable ‘smtpmail-default-smtp-server’ controls the default
     hostname of the server to use.  It is a string with an IP address
     or hostname.  It must be set before the SMTP library is loaded.  It
     has no effect if set after the SMTP library has been loaded, or if
     ‘smtpmail-smtp-server’ is defined.  It is usually set by system
     administrators in a site wide initialization file.

   The following example illustrates what you could put in ‘~/.emacs’ to
set the SMTP server name.

     ;; Send mail using SMTP via mail.example.org.
     (setq smtpmail-smtp-server "mail.example.org")

   SMTP is normally used on the registered “smtp” TCP service port 25.
Some environments use SMTP in “Mail Submission” mode, which uses port
587.  Using other ports is not uncommon, either for security by
obscurity purposes, port forwarding, or otherwise.

‘smtpmail-smtp-service’
     The variable ‘smtpmail-smtp-service’ controls the port on the
     server to contact.  It is either a string, in which case it will be
     translated into an integer using system calls, or an integer.

   The following example illustrates what you could put in ‘~/.emacs’ to
set the SMTP service port.

     ;; Send mail using SMTP on the mail submission port 587.
     (setq smtpmail-smtp-service 587)

3 Authentication
****************

Most SMTP servers require clients to authenticate themselves before they
are allowed to send mail.  Authentication usually involves supplying a
user name and password.

   If you have not configured anything, then the first time you try to
send mail via a server, Emacs (version 24.1 and later) prompts you for
the user name and password to use, and then offers to save the
information.  By default, Emacs stores authentication information in a
file ‘~/.authinfo’.

   The basic format of the ‘~/.authinfo’ file is one line for each set
of credentials.  Each line consists of pairs of variables and values.  A
simple example would be:

     machine mail.example.org port 25 login myuser password mypassword

This specifies that when using the SMTP server called ‘mail.example.org’
on port 25, Emacs should send the user name ‘myuser’ and the password
‘mypassword’.  Either or both of the login and password fields may be
absent, in which case Emacs prompts for the information when you try to
send mail.  (This replaces the old ‘smtpmail-auth-credentials’ variable
used prior to Emacs 24.1.)

   When the SMTP library connects to a host on a certain port, it
searches the ‘~/.authinfo’ file for a matching entry.  If an entry is
found, the authentication process is invoked and the credentials are
used.  If the variable ‘smtpmail-smtp-user’ is set to a non-‘nil’ value,
then only entries for that user are considered.  For more information on
the ‘~/.authinfo’ file, see auth-source (auth).

   The process by which the SMTP library authenticates you to the server
is known as “Simple Authentication and Security Layer” (SASL). There are
various SASL mechanisms, and this library supports three of them:
CRAM-MD5, PLAIN, and LOGIN.  It tries each of them, in that order, until
one succeeds.  The first uses a form of encryption to obscure your
password, while the other two do not.

4 Encryption
************

For greater security, you can encrypt your connection to the SMTP
server.  If this is to work, both Emacs and the server must support it.

   The SMTP library supports the “Transport Layer Security” (TLS), and
the older “Secure Sockets Layer” (SSL) encryption mechanisms.  It also
supports STARTTLS, which is a variant of TLS in which the initial
connection to the server is made in plain text, requesting a switch to
an encrypted channel for the rest of the process.

   The variable ‘smtpmail-stream-type’ controls what form of connection
the SMTP library uses.  The default value is ‘nil’, which means to use a
plain connection, but try to switch to a STARTTLS encrypted connection
if the server supports it.  Other possible values are: ‘starttls’ to
insist on STARTTLS; ‘ssl’ to use TLS/SSL; and ‘plain’ for no encryption.

   Use of any form of TLS/SSL requires support in Emacs.  You can either
use the built-in support (in Emacs 24.1 and later), or the ‘starttls.el’
Lisp library.  The built-in support uses the GnuTLS (1) library.  If
your Emacs has GnuTLS support built-in, the function
‘gnutls-available-p’ is defined and returns non-‘nil’.  Otherwise, you
must use the ‘starttls.el’ library (see that file for more information
on customization options, etc.).  The Lisp library requires one of the
following external tools to be installed:

  1. The GnuTLS command line tool ‘gnutls-cli’, which you can get from
     <https://www.gnu.org/software/gnutls/>.  This is the recommended
     tool, mainly because it can verify server certificates.

  2. The ‘starttls’ external program, which you can get from
     ‘starttls-*.tar.gz’ from <ftp://ftp.opaopa.org/pub/elisp/>.

   The SMTP server may also request that you verify your identity by
sending a certificate and the associated encryption key to the server.
If you need to do this, you can use an ‘~/.authinfo’ entry like this:

     machine mail.example.org port 25 key "~/.my_smtp_tls.key" cert "~/.my_smtp_tls.cert"

(This replaces the old ‘smtpmail-starttls-credentials’ variable used
prior to Emacs 24.1.)

   ---------- Footnotes ----------

   (1) <https://www.gnu.org/software/gnutls/>

5 Queued delivery
*****************

If you connect to the internet via a dialup connection, or for some
other reason don’t have permanent internet connection, sending mail will
fail when you are not connected.  The SMTP library implements queued
delivery, and the following variable control its behavior.

‘smtpmail-queue-mail’
     The variable ‘smtpmail-queue-mail’ controls whether a simple off
     line mail sender is active.  This variable is a boolean, and
     defaults to ‘nil’ (disabled).  If this is non-‘nil’, mail is not
     sent immediately but rather queued in the directory
     ‘smtpmail-queue-dir’ and can be later sent manually by invoking
     ‘smtpmail-send-queued-mail’ (typically when you connect to the
     internet).

‘smtpmail-queue-dir’
     The variable ‘smtpmail-queue-dir’ specifies the name of the
     directory to hold queued messages.  It defaults to
     ‘~/Mail/queued-mail/’.

   The function ‘smtpmail-send-queued-mail’ can be used to send any
queued mail when ‘smtpmail-queue-mail’ is enabled.  It is typically
invoked interactively with ‘M-x smtpmail-send-queued-mail <RET>’ when
you are connected to the internet.

6 Server workarounds
********************

Some SMTP servers have special requirements.  The following variables
implement support for common requirements.

‘smtpmail-local-domain’
     The variable ‘smtpmail-local-domain’ controls the hostname sent in
     the first ‘EHLO’ or ‘HELO’ command sent to the server.  It should
     be set only if the ‘system-name’ function returns a name that isn’t
     accepted by the server.  Do not set this variable unless your
     server complains.

‘smtpmail-sendto-domain’
     The variable ‘smtpmail-sendto-domain’ makes the SMTP library add
     ‘@’ and the specified value to recipients specified in the message
     when they are sent using the ‘RCPT TO’ command.  Some
     configurations of sendmail requires this behavior.  Don’t bother to
     set this unless you have get an error like:

                  Sending failed; SMTP protocol error

     when sending mail, and the debug buffer (see Debugging))
     contains an error such as:

                  RCPT TO: SOMEONE
                  501 SOMEONE: recipient address must contain a domain

7 Debugging
***********

Sometimes delivery fails, often with the generic error message ‘Sending
failed; SMTP protocol error’.  Enabling one or both of the following
variables and inspecting a trace buffer will often give clues to the
reason for the error.

‘smtpmail-debug-info’
     The variable ‘smtpmail-debug-info’ controls whether to print the
     SMTP protocol exchange in the minibuffer, and retain the entire
     exchange in a buffer ‘*trace of SMTP session to SERVER*’, where
     SERVER is the name of the mail server to which you send mail.

‘smtpmail-debug-verb’
     The variable ‘smtpmail-debug-verb’ controls whether to send the
     ‘VERB’ token to the server.  The ‘VERB’ server instructs the server
     to be more verbose, and often also to attempt final delivery while
     your SMTP session is still running.  It is usually only useful
     together with ‘smtpmail-debug-info’.  Note that this may cause mail
     delivery to take considerable time if the final destination cannot
     accept mail.

8 GNU Free Documentation License
********************************

                     Version 1.3, 3 November 2008

     Copyright © 2000, 2001, 2002, 2007, 2008 Free Software Foundation, Inc.
     <https://fsf.org/>

     Everyone is permitted to copy and distribute verbatim copies
     of this license document, but changing it is not allowed.

  0. PREAMBLE

     The purpose of this License is to make a manual, textbook, or other
     functional and useful document “free” in the sense of freedom: to
     assure everyone the effective freedom to copy and redistribute it,
     with or without modifying it, either commercially or
     noncommercially.  Secondarily, this License preserves for the
     author and publisher a way to get credit for their work, while not
     being considered responsible for modifications made by others.

     This License is a kind of “copyleft”, which means that derivative
     works of the document must themselves be free in the same sense.
     It complements the GNU General Public License, which is a copyleft
     license designed for free software.

     We have designed this License in order to use it for manuals for
     free software, because free software needs free documentation: a
     free program should come with manuals providing the same freedoms
     that the software does.  But this License is not limited to
     software manuals; it can be used for any textual work, regardless
     of subject matter or whether it is published as a printed book.  We
     recommend this License principally for works whose purpose is
     instruction or reference.

  1. APPLICABILITY AND DEFINITIONS

     This License applies to any manual or other work, in any medium,
     that contains a notice placed by the copyright holder saying it can
     be distributed under the terms of this License.  Such a notice
     grants a world-wide, royalty-free license, unlimited in duration,
     to use that work under the conditions stated herein.  The
     “Document”, below, refers to any such manual or work.  Any member
     of the public is a licensee, and is addressed as “you”.  You accept
     the license if you copy, modify or distribute the work in a way
     requiring permission under copyright law.

     A “Modified Version” of the Document means any work containing the
     Document or a portion of it, either copied verbatim, or with
     modifications and/or translated into another language.

     A “Secondary Section” is a named appendix or a front-matter section
     of the Document that deals exclusively with the relationship of the
     publishers or authors of the Document to the Document’s overall
     subject (or to related matters) and contains nothing that could
     fall directly within that overall subject.  (Thus, if the Document
     is in part a textbook of mathematics, a Secondary Section may not
     explain any mathematics.)  The relationship could be a matter of
     historical connection with the subject or with related matters, or
     of legal, commercial, philosophical, ethical or political position
     regarding them.

     The “Invariant Sections” are certain Secondary Sections whose
     titles are designated, as being those of Invariant Sections, in the
     notice that says that the Document is released under this License.
     If a section does not fit the above definition of Secondary then it
     is not allowed to be designated as Invariant.  The Document may
     contain zero Invariant Sections.  If the Document does not identify
     any Invariant Sections then there are none.

     The “Cover Texts” are certain short passages of text that are
     listed, as Front-Cover Texts or Back-Cover Texts, in the notice
     that says that the Document is released under this License.  A
     Front-Cover Text may be at most 5 words, and a Back-Cover Text may
     be at most 25 words.

     A “Transparent” copy of the Document means a machine-readable copy,
     represented in a format whose specification is available to the
     general public, that is suitable for revising the document
     straightforwardly with generic text editors or (for images composed
     of pixels) generic paint programs or (for drawings) some widely
     available drawing editor, and that is suitable for input to text
     formatters or for automatic translation to a variety of formats
     suitable for input to text formatters.  A copy made in an otherwise
     Transparent file format whose markup, or absence of markup, has
     been arranged to thwart or discourage subsequent modification by
     readers is not Transparent.  An image format is not Transparent if
     used for any substantial amount of text.  A copy that is not
     “Transparent” is called “Opaque”.

     Examples of suitable formats for Transparent copies include plain
     ASCII without markup, Texinfo input format, LaTeX input format,
     SGML or XML using a publicly available DTD, and standard-conforming
     simple HTML, PostScript or PDF designed for human modification.
     Examples of transparent image formats include PNG, XCF and JPG.
     Opaque formats include proprietary formats that can be read and
     edited only by proprietary word processors, SGML or XML for which
     the DTD and/or processing tools are not generally available, and
     the machine-generated HTML, PostScript or PDF produced by some word
     processors for output purposes only.

     The “Title Page” means, for a printed book, the title page itself,
     plus such following pages as are needed to hold, legibly, the
     material this License requires to appear in the title page.  For
     works in formats which do not have any title page as such, “Title
     Page” means the text near the most prominent appearance of the
     work’s title, preceding the beginning of the body of the text.

     The “publisher” means any person or entity that distributes copies
     of the Document to the public.

     A section “Entitled XYZ” means a named subunit of the Document
     whose title either is precisely XYZ or contains XYZ in parentheses
     following text that translates XYZ in another language.  (Here XYZ
     stands for a specific section name mentioned below, such as
     “Acknowledgements”, “Dedications”, “Endorsements”, or “History”.)
     To “Preserve the Title” of such a section when you modify the
     Document means that it remains a section “Entitled XYZ” according
     to this definition.

     The Document may include Warranty Disclaimers next to the notice
     which states that this License applies to the Document.  These
     Warranty Disclaimers are considered to be included by reference in
     this License, but only as regards disclaiming warranties: any other
     implication that these Warranty Disclaimers may have is void and
     has no effect on the meaning of this License.

  2. VERBATIM COPYING

     You may copy and distribute the Document in any medium, either
     commercially or noncommercially, provided that this License, the
     copyright notices, and the license notice saying this License
     applies to the Document are reproduced in all copies, and that you
     add no other conditions whatsoever to those of this License.  You
     may not use technical measures to obstruct or control the reading
     or further copying of the copies you make or distribute.  However,
     you may accept compensation in exchange for copies.  If you
     distribute a large enough number of copies you must also follow the
     conditions in section 3.

     You may also lend copies, under the same conditions stated above,
     and you may publicly display copies.

  3. COPYING IN QUANTITY

     If you publish printed copies (or copies in media that commonly
     have printed covers) of the Document, numbering more than 100, and
     the Document’s license notice requires Cover Texts, you must
     enclose the copies in covers that carry, clearly and legibly, all
     these Cover Texts: Front-Cover Texts on the front cover, and
     Back-Cover Texts on the back cover.  Both covers must also clearly
     and legibly identify you as the publisher of these copies.  The
     front cover must present the full title with all words of the title
     equally prominent and visible.  You may add other material on the
     covers in addition.  Copying with changes limited to the covers, as
     long as they preserve the title of the Document and satisfy these
     conditions, can be treated as verbatim copying in other respects.

     If the required texts for either cover are too voluminous to fit
     legibly, you should put the first ones listed (as many as fit
     reasonably) on the actual cover, and continue the rest onto
     adjacent pages.

     If you publish or distribute Opaque copies of the Document
     numbering more than 100, you must either include a machine-readable
     Transparent copy along with each Opaque copy, or state in or with
     each Opaque copy a computer-network location from which the general
     network-using public has access to download using public-standard
     network protocols a complete Transparent copy of the Document, free
     of added material.  If you use the latter option, you must take
     reasonably prudent steps, when you begin distribution of Opaque
     copies in quantity, to ensure that this Transparent copy will
     remain thus accessible at the stated location until at least one
     year after the last time you distribute an Opaque copy (directly or
     through your agents or retailers) of that edition to the public.

     It is requested, but not required, that you contact the authors of
     the Document well before redistributing any large number of copies,
     to give them a chance to provide you with an updated version of the
     Document.

  4. MODIFICATIONS

     You may copy and distribute a Modified Version of the Document
     under the conditions of sections 2 and 3 above, provided that you
     release the Modified Version under precisely this License, with the
     Modified Version filling the role of the Document, thus licensing
     distribution and modification of the Modified Version to whoever
     possesses a copy of it.  In addition, you must do these things in
     the Modified Version:

       A. Use in the Title Page (and on the covers, if any) a title
          distinct from that of the Document, and from those of previous
          versions (which should, if there were any, be listed in the
          History section of the Document).  You may use the same title
          as a previous version if the original publisher of that
          version gives permission.

       B. List on the Title Page, as authors, one or more persons or
          entities responsible for authorship of the modifications in
          the Modified Version, together with at least five of the
          principal authors of the Document (all of its principal
          authors, if it has fewer than five), unless they release you
          from this requirement.

       C. State on the Title page the name of the publisher of the
          Modified Version, as the publisher.

       D. Preserve all the copyright notices of the Document.

       E. Add an appropriate copyright notice for your modifications
          adjacent to the other copyright notices.

       F. Include, immediately after the copyright notices, a license
          notice giving the public permission to use the Modified
          Version under the terms of this License, in the form shown in
          the Addendum below.

       G. Preserve in that license notice the full lists of Invariant
          Sections and required Cover Texts given in the Document’s
          license notice.

       H. Include an unaltered copy of this License.

       I. Preserve the section Entitled “History”, Preserve its Title,
          and add to it an item stating at least the title, year, new
          authors, and publisher of the Modified Version as given on the
          Title Page.  If there is no section Entitled “History” in the
          Document, create one stating the title, year, authors, and
          publisher of the Document as given on its Title Page, then add
          an item describing the Modified Version as stated in the
          previous sentence.

       J. Preserve the network location, if any, given in the Document
          for public access to a Transparent copy of the Document, and
          likewise the network locations given in the Document for
          previous versions it was based on.  These may be placed in the
          “History” section.  You may omit a network location for a work
          that was published at least four years before the Document
          itself, or if the original publisher of the version it refers
          to gives permission.

       K. For any section Entitled “Acknowledgements” or “Dedications”,
          Preserve the Title of the section, and preserve in the section
          all the substance and tone of each of the contributor
          acknowledgements and/or dedications given therein.

       L. Preserve all the Invariant Sections of the Document, unaltered
          in their text and in their titles.  Section numbers or the
          equivalent are not considered part of the section titles.

       M. Delete any section Entitled “Endorsements”.  Such a section
          may not be included in the Modified Version.

       N. Do not retitle any existing section to be Entitled
          “Endorsements” or to conflict in title with any Invariant
          Section.

       O. Preserve any Warranty Disclaimers.

     If the Modified Version includes new front-matter sections or
     appendices that qualify as Secondary Sections and contain no
     material copied from the Document, you may at your option designate
     some or all of these sections as invariant.  To do this, add their
     titles to the list of Invariant Sections in the Modified Version’s
     license notice.  These titles must be distinct from any other
     section titles.

     You may add a section Entitled “Endorsements”, provided it contains
     nothing but endorsements of your Modified Version by various
     parties—for example, statements of peer review or that the text has
     been approved by an organization as the authoritative definition of
     a standard.

     You may add a passage of up to five words as a Front-Cover Text,
     and a passage of up to 25 words as a Back-Cover Text, to the end of
     the list of Cover Texts in the Modified Version.  Only one passage
     of Front-Cover Text and one of Back-Cover Text may be added by (or
     through arrangements made by) any one entity.  If the Document
     already includes a cover text for the same cover, previously added
     by you or by arrangement made by the same entity you are acting on
     behalf of, you may not add another; but you may replace the old
     one, on explicit permission from the previous publisher that added
     the old one.

     The author(s) and publisher(s) of the Document do not by this
     License give permission to use their names for publicity for or to
     assert or imply endorsement of any Modified Version.

  5. COMBINING DOCUMENTS

     You may combine the Document with other documents released under
     this License, under the terms defined in section 4 above for
     modified versions, provided that you include in the combination all
     of the Invariant Sections of all of the original documents,
     unmodified, and list them all as Invariant Sections of your
     combined work in its license notice, and that you preserve all
     their Warranty Disclaimers.

     The combined work need only contain one copy of this License, and
     multiple identical Invariant Sections may be replaced with a single
     copy.  If there are multiple Invariant Sections with the same name
     but different contents, make the title of each such section unique
     by adding at the end of it, in parentheses, the name of the
     original author or publisher of that section if known, or else a
     unique number.  Make the same adjustment to the section titles in
     the list of Invariant Sections in the license notice of the
     combined work.

     In the combination, you must combine any sections Entitled
     “History” in the various original documents, forming one section
     Entitled “History”; likewise combine any sections Entitled
     “Acknowledgements”, and any sections Entitled “Dedications”.  You
     must delete all sections Entitled “Endorsements.”

  6. COLLECTIONS OF DOCUMENTS

     You may make a collection consisting of the Document and other
     documents released under this License, and replace the individual
     copies of this License in the various documents with a single copy
     that is included in the collection, provided that you follow the
     rules of this License for verbatim copying of each of the documents
     in all other respects.

     You may extract a single document from such a collection, and
     distribute it individually under this License, provided you insert
     a copy of this License into the extracted document, and follow this
     License in all other respects regarding verbatim copying of that
     document.

  7. AGGREGATION WITH INDEPENDENT WORKS

     A compilation of the Document or its derivatives with other
     separate and independent documents or works, in or on a volume of a
     storage or distribution medium, is called an “aggregate” if the
     copyright resulting from the compilation is not used to limit the
     legal rights of the compilation’s users beyond what the individual
     works permit.  When the Document is included in an aggregate, this
     License does not apply to the other works in the aggregate which
     are not themselves derivative works of the Document.

     If the Cover Text requirement of section 3 is applicable to these
     copies of the Document, then if the Document is less than one half
     of the entire aggregate, the Document’s Cover Texts may be placed
     on covers that bracket the Document within the aggregate, or the
     electronic equivalent of covers if the Document is in electronic
     form.  Otherwise they must appear on printed covers that bracket
     the whole aggregate.

  8. TRANSLATION

     Translation is considered a kind of modification, so you may
     distribute translations of the Document under the terms of section
     4.  Replacing Invariant Sections with translations requires special
     permission from their copyright holders, but you may include
     translations of some or all Invariant Sections in addition to the
     original versions of these Invariant Sections.  You may include a
     translation of this License, and all the license notices in the
     Document, and any Warranty Disclaimers, provided that you also
     include the original English version of this License and the
     original versions of those notices and disclaimers.  In case of a
     disagreement between the translation and the original version of
     this License or a notice or disclaimer, the original version will
     prevail.

     If a section in the Document is Entitled “Acknowledgements”,
     “Dedications”, or “History”, the requirement (section 4) to
     Preserve its Title (section 1) will typically require changing the
     actual title.

  9. TERMINATION

     You may not copy, modify, sublicense, or distribute the Document
     except as expressly provided under this License.  Any attempt
     otherwise to copy, modify, sublicense, or distribute it is void,
     and will automatically terminate your rights under this License.

     However, if you cease all violation of this License, then your
     license from a particular copyright holder is reinstated (a)
     provisionally, unless and until the copyright holder explicitly and
     finally terminates your license, and (b) permanently, if the
     copyright holder fails to notify you of the violation by some
     reasonable means prior to 60 days after the cessation.

     Moreover, your license from a particular copyright holder is
     reinstated permanently if the copyright holder notifies you of the
     violation by some reasonable means, this is the first time you have
     received notice of violation of this License (for any work) from
     that copyright holder, and you cure the violation prior to 30 days
     after your receipt of the notice.

     Termination of your rights under this section does not terminate
     the licenses of parties who have received copies or rights from you
     under this License.  If your rights have been terminated and not
     permanently reinstated, receipt of a copy of some or all of the
     same material does not give you any rights to use it.

  10. FUTURE REVISIONS OF THIS LICENSE

     The Free Software Foundation may publish new, revised versions of
     the GNU Free Documentation License from time to time.  Such new
     versions will be similar in spirit to the present version, but may
     differ in detail to address new problems or concerns.  See
     <https://www.gnu.org/licenses/>.

     Each version of the License is given a distinguishing version
     number.  If the Document specifies that a particular numbered
     version of this License “or any later version” applies to it, you
     have the option of following the terms and conditions either of
     that specified version or of any later version that has been
     published (not as a draft) by the Free Software Foundation.  If the
     Document does not specify a version number of this License, you may
     choose any version ever published (not as a draft) by the Free
     Software Foundation.  If the Document specifies that a proxy can
     decide which future versions of this License can be used, that
     proxy’s public statement of acceptance of a version permanently
     authorizes you to choose that version for the Document.

  11. RELICENSING

     “Massive Multiauthor Collaboration Site” (or “MMC Site”) means any
     World Wide Web server that publishes copyrightable works and also
     provides prominent facilities for anybody to edit those works.  A
     public wiki that anybody can edit is an example of such a server.
     A “Massive Multiauthor Collaboration” (or “MMC”) contained in the
     site means any set of copyrightable works thus published on the MMC
     site.

     “CC-BY-SA” means the Creative Commons Attribution-Share Alike 3.0
     license published by Creative Commons Corporation, a not-for-profit
     corporation with a principal place of business in San Francisco,
     California, as well as future copyleft versions of that license
     published by that same organization.

     “Incorporate” means to publish or republish a Document, in whole or
     in part, as part of another Document.

     An MMC is “eligible for relicensing” if it is licensed under this
     License, and if all works that were first published under this
     License somewhere other than this MMC, and subsequently
     incorporated in whole or in part into the MMC, (1) had no cover
     texts or invariant sections, and (2) were thus incorporated prior
     to November 1, 2008.

     The operator of an MMC Site may republish an MMC contained in the
     site under CC-BY-SA on the same site at any time before August 1,
     2009, provided the MMC is eligible for relicensing.

ADDENDUM: How to use this License for your documents
====================================================

To use this License in a document you have written, include a copy of
the License in the document and put the following copyright and license
notices just after the title page:

       Copyright (C)  YEAR  YOUR NAME.
       Permission is granted to copy, distribute and/or modify this document
       under the terms of the GNU Free Documentation License, Version 1.3
       or any later version published by the Free Software Foundation;
       with no Invariant Sections, no Front-Cover Texts, and no Back-Cover
       Texts.  A copy of the license is included in the section entitled ``GNU
       Free Documentation License''.

   If you have Invariant Sections, Front-Cover Texts and Back-Cover
Texts, replace the “with...Texts.” line with this:

         with the Invariant Sections being LIST THEIR TITLES, with
         the Front-Cover Texts being LIST, and with the Back-Cover Texts
         being LIST.

   If you have Invariant Sections without Cover Texts, or some other
combination of the three, merge those two alternatives to suit the
situation.

   If your document contains nontrivial examples of program code, we
recommend releasing these examples in parallel under your choice of free
software license, such as the GNU General Public License, to permit
their use in free software.

9 Index
*******

9.1 Concept Index
=================

9.2 Function and Variable Index
===============================